%define major		1
%define libname		%mklibname %{name} %{major}
%define devname		%mklibname %{name} -d
%define libnameui	%mklibname qmmpui %{major}
%define devnameui	%mklibname qmmpui -d

######################
# Hardcode PLF build
%define build_plf 0
######################

%if %{build_plf}
%define distsuffix plf
%define extrarelsuffix plf
%endif

Summary:	Qt-based Multimedia Player
Name:		qmmp
Version:	1.2.2
Release:	1%{?extrarelsuffix}
License:	GPLv2+
Group:		Sound
Url:		http://qmmp.ylsoftware.com
Source0:	http://qmmp.ylsoftware.com/files/%{name}-%{version}.tar.bz2
Patch0:		qmmp-1.1.11-initial-preference.patch
BuildRequires:	cmake >= 2.8.11
BuildRequires:	qt5-linguist-tools
BuildRequires:	ffmpeg-devel
%if %{build_plf}
BuildRequires:	libfaad2-devel
%else
BuildConflicts:	libfaad2-devel
%endif
BuildRequires:	libgme-devel
BuildRequires:	libmpcdec-devel
BuildRequires:	sidplay-devel
BuildRequires:	wildmidi-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(enca) >= 1.9
BuildRequires:	pkgconfig(flac)
BuildRequires:	pkgconfig(jack) >= 1.9.8
BuildRequires:	pkgconfig(libarchive) >= 3.2.0
BuildRequires:	pkgconfig(libbs2b) >= 3.0.0
BuildRequires:	pkgconfig(libcddb)
BuildRequires:	pkgconfig(libcdio)
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(libmms) >= 0.4
BuildRequires:	pkgconfig(libmodplug)
BuildRequires:	pkgconfig(libprojectM) >= 2.0.0
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(libsidplay2)
BuildRequires:	pkgconfig(libsidplayfp) >= 1.0.3
#BuildRequires:	pkgconfig(libuv)
BuildRequires:	pkgconfig(mad)
BuildRequires:	pkgconfig(opus) >= 1.0.2
BuildRequires:	pkgconfig(opusfile) >= 0.2
BuildRequires:	pkgconfig(Qt5Core) >= 5.4.0
BuildRequires:	pkgconfig(Qt5DBus) >= 5.4.0
BuildRequires:	pkgconfig(Qt5Multimedia) >= 5.4.0
BuildRequires:	pkgconfig(Qt5Network) >= 5.4.0
BuildRequires:	pkgconfig(Qt5Widgets) >= 5.4.0
BuildRequires:	pkgconfig(Qt5X11Extras) >= 5.4.0
BuildRequires:	pkgconfig(samplerate) >= 0.1.8
# Do not remove sdl-headers needed by sid-ogg. Sflo
BuildRequires:	pkgconfig(sdl)
BuildRequires:	pkgconfig(shout)
BuildRequires:	pkgconfig(sndfile) >= 1.0.21
BuildRequires:	pkgconfig(soxr)
BuildRequires:	pkgconfig(taglib) >= 1.10
BuildRequires:	pkgconfig(udisks2)
BuildRequires:	pkgconfig(vorbis)
BuildRequires:	pkgconfig(wavpack)
BuildRequires:	pkgconfig(x11)
Requires:	%{libname} = %{EVRD}
Requires:	%{libnameui} = %{EVRD}
Requires:	%{name}-plugins = %{EVRD}
Requires:	unzip
Requires:	wildmidi
Suggests:	%{name}-aac = %{EVRD}
%if %{mdvver} >= 201210
Suggests:	%{name}-ffmpeg = %{EVRD}
%else
Suggests:	%{name}-ffmpeg-legacy = %{EVRD}
%endif
Suggests:	%{name}-jack = %{EVRD}
Suggests:	%{name}-modplug = %{EVRD}
Suggests:	%{name}-musepack = %{EVRD}
Suggests:	%{name}-opus = %{EVRD}
Suggests:	%{name}-oss = %{EVRD}
Suggests:	%{name}-simple-ui = %{EVRD}
Suggests:	%{name}-wavpack = %{EVRD}
Suggests:	%{name}-plugin-pack

%description
This program is an audio-player, written with help of Qt library. The user
interface is similar to winamp or xmms.
Main opportunities:
* Winamp and xmms skins support;
* plugins support;
* MPEG1 layer 1/2/3 support;
* Ogg Vorbis support;
* native FLAC support;
* Musepack support;
* WavePack support;
* ModPlug support;
* WMA support;
* PCM WAVE support;
* AlSA sound output;
* JACK sound output;
* OSS sound output;
* PulseAudio output;
* Last.fm scrobbler;
* D-Bus support;
* Spectrum Analyzer;
* sample rate conversion;
* streaming support (MP3, Vorbis via IceCast/ShoutCast).

%files
%doc AUTHORS ChangeLog
%{_bindir}/%{name}
%{_datadir}/applications/*.desktop
%{_iconsdir}/hicolor/*/apps/*
%{_datadir}/%{name}

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Library for %{name}
Group:		System/Libraries

%description -n %{libname}
Qmmp is an audio-player, written with help of Qt library.
This package contains the library needed by %{name}.

%files -n %{libname}
%doc AUTHORS ChangeLog
%{_libdir}/libqmmp.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libnameui}
Summary:	Library for %{name}
Group:		System/Libraries

%description -n %{libnameui}
Qmmp is an audio-player, written with help of Qt library.
This package contains the library needed by %{name}.

%files -n %{libnameui}
%doc AUTHORS ChangeLog
%{_libdir}/libqmmpui.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
Qmmp is an audio-player, written with help of Qt library.
This package contains the files needed for developing applications
which use %{name}.

%files -n %{devname}
%doc AUTHORS ChangeLog
%{_includedir}/%{name}
%{_libdir}/libqmmp.so
%{_libdir}/pkgconfig/qmmp.pc

#----------------------------------------------------------------------------

%package -n %{devnameui}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libnameui} = %{EVRD}
Provides:	%{name}ui-devel = %{EVRD}
Conflicts:	%{_lib}qmmp-devel < 0.7.2

%description -n %{devnameui}
Qmmp is an audio-player, written with help of Qt library.
This package contains the files needed for developing applications
which use %{name}.

%files -n %{devnameui}
%doc AUTHORS ChangeLog
%{_includedir}/qmmpui
%{_libdir}/libqmmpui.so
%{_libdir}/pkgconfig/qmmpui.pc

#----------------------------------------------------------------------------

%if %{build_plf}
%package aac
Summary:	Qmmp AAC Input Plugin
Group:		Sound

%description aac
This is the AAC Input plug-in for Qmmp.

This package is in restricted repository because AAC codec is patent-protected.

%files aac
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libaac.so
%endif

#----------------------------------------------------------------------------

#  ffmpeg-legacy in LTS
%if %{mdvver} >= 201210
%package ffmpeg
Summary:	Qmmp FFMPEG Input Plugin
Group:		Sound

%description ffmpeg
This is the FFMPEG Input Plugin for Qmmp.

%files ffmpeg
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libffmpeg.so

%else

%package ffmpeg-legacy
Summary:	Qmmp FFMPEG Input Plugin
Group:		Sound

%description ffmpeg-legacy
This is the FFMPEG Input Plugin for Qmmp.

%files ffmpeg-legacy
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libffmpeg_legacy.so
%endif

#----------------------------------------------------------------------------

%package jack
Summary:	Qmmp Jack Output Plugin
Group:		Sound

%description jack
This is the Jack Output Plugin for Qmmp.

%files jack
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Output/libjack.so

#----------------------------------------------------------------------------

%package modplug
Summary:	Qmmp Modplug Input Plugin
Group:		Sound

%description modplug
This is the Modplug Input Plugin for Qmmp.

%files modplug
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libmodplug.so

#----------------------------------------------------------------------------

%package musepack
Summary:	Qmmp MusePack Output Plugin
Group:		Sound

%description musepack
This is the Musepack Input Plugin for Qmmp.

%files musepack
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libmpc.so

#----------------------------------------------------------------------------
%package opus
Summary:	Qmmp Opus Input Plugin
Group:		Sound

%description opus
This is the Opus Input Plugin for Qmmp.

%files opus
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libopus.so

#----------------------------------------------------------------------------

%package oss
Summary:	Qmmp OSS Output Plugin
Group:		Sound

%description oss
This is the Jack OSS Plugin for Qmmp.

%files oss
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Output/liboss.so

#----------------------------------------------------------------------------

%package plugins
Summary:	Qmmp Plugins
Group:		Sound

%description plugins
Qmmp is an audio-player, written with help of Qt library.
This contains basic plug-in distribution.

%files plugins
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libflac.so
%{_libdir}/%{name}/Input/libmad.so
%{_libdir}/%{name}/Input/libsndfile.so
%{_libdir}/%{name}/Input/libvorbis.so
%{_libdir}/%{name}/Input/libcdaudio.so
%{_libdir}/%{name}/Input/libcue.so
%{_libdir}/%{name}/Input/libgme.so
%{_libdir}/%{name}/Input/libwildmidi.so
%{_libdir}/%{name}/Input/libarchive.so
%{_libdir}/%{name}/Output/libalsa.so
%{_libdir}/%{name}/Output/libpulseaudio.so
%{_libdir}/%{name}/Output/libqtmultimedia.so
%{_libdir}/%{name}/Output/libnull.so
%{_libdir}/%{name}/Output/libshout.so
%{_libdir}/%{name}/General/libnotifier.so
%{_libdir}/%{name}/General/libscrobbler.so
%{_libdir}/%{name}/General/libstatusicon.so
%{_libdir}/%{name}/General/libfileops.so
%{_libdir}/%{name}/General/libhotkey.so
%{_libdir}/%{name}/General/liblyrics.so
%{_libdir}/%{name}/General/libmpris.so
%{_libdir}/%{name}/General/libcovermanager.so
%{_libdir}/%{name}/General/libkdenotify.so
%{_libdir}/%{name}/General/libstreambrowser.so
%{_libdir}/%{name}/General/libconverter.so
%{_libdir}/%{name}/General/libcopypaste.so
%{_libdir}/%{name}/General/libtrackchange.so
%{_libdir}/%{name}/General/libudisks2.so
%{_libdir}/%{name}/General/libgnomehotkey.so
%{_libdir}/%{name}/General/librgscan.so
%{_libdir}/%{name}/PlayListFormats/*
%{_libdir}/%{name}/CommandLineOptions/libincdecvolumeoption.so
%{_libdir}/%{name}/CommandLineOptions/libseekoption.so
%{_libdir}/%{name}/CommandLineOptions/libstatusoption.so
%{_libdir}/%{name}/CommandLineOptions/libplaylistoption.so
%{_libdir}/%{name}/Effect/libbs2b.so
%{_libdir}/%{name}/Effect/libladspa.so
%{_libdir}/%{name}/Effect/libcrossfade.so
%{_libdir}/%{name}/Effect/libsoxr.so
%{_libdir}/%{name}/Effect/libstereo.so
%{_libdir}/%{name}/Effect/libfilewriter.so
%{_libdir}/%{name}/Engines/libmplayer.so
%{_libdir}/%{name}/FileDialogs/libqmmpfiledialog.so
%{_libdir}/%{name}/FileDialogs/libtwopanelfiledialog.so
%{_libdir}/%{name}/Transports/libhttp.so
%{_libdir}/%{name}/Transports/libmms.so
%{_libdir}/%{name}/Visual/libanalyzer.so
%{_libdir}/%{name}/Visual/libprojectm.so
%{_libdir}/%{name}/Ui/libskinned.so

#----------------------------------------------------------------------------

%package sid
Summary:	Qmmp SID Input Plugin
Group:		Sound

%description sid
This is the SID Input Plugin for Qmmp.

%files sid
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libsid.so

#----------------------------------------------------------------------------

%package simple-ui
Summary:	Qmmp Simple UI Plugin
Group:		Sound

%description simple-ui
This is the Simple UI Plugin for Qmmp (simple user interface based on standard
widgets set).

%files simple-ui
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Ui/libqsui.so

#----------------------------------------------------------------------------

%package wavpack
Summary:	Qmmp WavPack Input Plugin
Group:		Sound

%description wavpack
This is the WavPack Input Plugin for Qmmp.

%files wavpack
%doc AUTHORS ChangeLog
%{_libdir}/%{name}/Input/libwavpack.so

#----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p1


%build
#oss3 support is deprecated upstream for now I'll enable it ...
%cmake_qt5 \
	-DUSE_OSS:BOOL=TRUE \
	-DUSE_HAL:BOOL=FALSE \
	-DUSE_UDISKS2:BOOL=TRUE \
	-DUSE_RPATH=TRUE \
	-DCMAKE_INSTALL_PREFIX=%{_prefix}

%make


%install
%makeinstall_std -C build


%changelog

* Sat Jun 02 2018 Giovanni Mariani <mc2374@mclink.it> 1.2.2-1
- (4e0c76f) Updated to release 1.2.2

* Fri Apr 27 2018 Giovanni Mariani <mc2374@mclink.it> 1.2.1-2
- (96b885c) Add Suggests for qmmp-opus, bump release

* Tue Apr 24 2018 Giovanni Mariani <mc2374@mclink.it> 1.2.1-1
- (8b46211) Updated to release 1.2.1

* Thu Mar 08 2018 gvm <mc2374@mclink.it> 1.2.0-2
- (0ca0020) Rebuild for new wavpack, bump release.

* Sun Nov 26 2017 Giovanni Mariani <mc2374@mclink.it> 1.2.0-1
- (a30f3b5) Fix stupid typo
- (Giovanni Mariani: 8c6e35e) Fixed BReqs
- (Giovanni Mariani: da789f3) Updated to release 1.2.0, updated BReqs and file lists

* Mon Oct 23 2017 Giovanni Mariani <mc2374@mclink.it> 1.1.12-1
- (308396d) Updated to release 1.1.12

* Sat Oct 21 2017 Giovanni Mariani <mc2374@mclink.it> 1.1.11-1
- (c6cc081) Updated to release 1.1.11, rediffed P0 and updated BReqs

* Sat Aug 19 2017 Giovanni Mariani <mc2374@mclink.it> 1.1.10-1
- (3f42405) Updated to release 1.1.10 and updated BReqs

* Fri Jun 02 2017 Giovanni Mariani <mc2374@mclink.it> 1.1.8-1
- (ef060a2) Updated to release 1.1.8

* Sun Feb 05 2017 Giovanni Mariani <mc2374@mclink.it> 1.1.7-1
- (892eaae) Updated to release 1.1.7, updated file lists and BReqs

* Fri Nov 25 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.1.5-2
- (0dc99e2) Bump release

* Fri Nov 11 2016 Giovanni Mariani <mc2374@mclink.it> 1.1.5-1
- (6dc9f58) Updated to release 1.1.5

* Fri Oct 07 2016 Giovanni Mariani <mc2374@mclink.it> 1.1.4-1
- (2dfaeb2) Updated to release 1.1.4 and updated BReqs

* Thu Sep 29 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.1.3-1
- (205f950) Don't build Qt5Multimedia plugin
- (Andrey Bondrov: 8036433) Build requires pkgconfig(Qt5Multimedia)
- (Andrey Bondrov: 8036433) Update files
- (Andrey Bondrov: 157faef) New version 1.1.3
- (Andrey Bondrov: 157faef) Drop merged http-fix patch

* Sat Apr 16 2016 abfonly <abfonly@gmail.com> 1.0.7-1
- (8b481ec) Log: Update to 1.0.7
- (8b481ec) patched for https stream transport
- (8b481ec) * added ffmpeg 3.0 support
- (8b481ec) * added support for theme change event in the qsui plugin
- (8b481ec) * fixed sendig multiple play commands when opening several files for playback
- (8b481ec) * fixed memory leaks
- (8b481ec) * fixed qt5.6 support

* Sun Jan 24 2016 Giovanni Mariani <mc2374@mclink.it> 1.0.5-1
- (9240530) Updated to release 1.0.5

* Mon Nov 23 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.0.2-1
- (986dd7e) New version 1.0.2
- (986dd7e) Switch to Qt5
- (986dd7e) New library major 1

* Mon Sep 07 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.9.1-2
- (fd04469) Suggest simple UI plugin

* Mon Sep 07 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.9.1-1
- (a4965ca) New version 0.9.1
- (a4965ca) Re-diff initial preference patch
- (a4965ca) simple-ui plugin is moved here from plugin-pack package

* Tue Aug 11 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.8.5-3
- (9d331d8) Don't set high priority for qmmp_enqueue.desktop

* Mon Aug 10 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.8.5-2
- (465b1dd) Adjust QMMP priority in KDE

* Thu Aug 06 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.8.5-1
- (8f8f6d5) New version 0.8.5
- (8f8f6d5) Use udisks2 instead of udisks

* Tue Mar 17 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.8.3-2
- (dcddcb2) Bump release

* Wed Feb 25 2015 Denis Silakov <denis.silakov@rosalab.ru> 0.8.3-1
- (98ee8c8) Updated to 0.8.3

* Mon Oct 20 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.8.2-1
- (f8affcb) Spec cleanup
- (abfonly: 5bf3f44) Changelog: 0.8.2 added transifex integration
- (abfonly: 5bf3f44) added webm support improved image scaling quality
- (abfonly: 5bf3f44) fixed xspf parsing
- (abfonly: 5bf3f44) fixed cover loading sequence
- (abfonly: 5bf3f44) fixed main window activation under windows
- (abfonly: 5bf3f44) fixed analyzer color settings
- (abfonly: 5bf3f44) fixed typos
- (abfonly: 5bf3f44) fixed possible segmentation fault in the opus;
- (abfonly: 5bf3f44) fixed separator of the file filters
- (abfonly: 5bf3f44) reduced tag reading delay (requires TagLib 1.8 or higher)
- (abfonly: 5bf3f44) updated Russian translation
- (abfonly: 5bf3f44) updated Ukrainian translation
- (abfonly: 5bf3f44) updated Japanese translation


